> For the complete documentation index, see [llms.txt](https://docs.trymito.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.trymito.io/mito-for-streamlit/experienced-streamlit-users.md).

# Experienced Streamlit Users

If you have existing Streamlit applications that you're maintaining where you're exposing data to end-users, Mito can be used as a drop-in replacement for `st.dataframe` and `st.data_editor` that offers an data exploration experience that can be more intuative to users coming from Excel and Google Sheets.

## As a replacement for st.dataframe

Mito can be used as a drop-in replacement for `st.dataframe` - that allows users to explore their data in a more flexible way than the standard dataframe viewer. With Mito, users will have the option to go beyond just seeing the underlying data - they will also be able to add filters, create pivot tables, create graphs, and more.&#x20;

```python
# Before
import streamlit as st
st.dataframe(df)

# After
from mitosheet.streamlit.v1 import spreadsheet
spreadsheet(df)
```

## As a replacement for st.data\_editor

Currently, `st.data_editor` only allows editing of dataframe values and rows. While this is well optimized for simple use cases, there is often the need to let users to do more dramatic data editing operations like deleting columns, changing dtypes, adding filters, and even writing spreadsheet formulas. Similarly to above, the Mito spreadsheet can be used as a drop-in replacement for `st.data_editor`.&#x20;

```python
# Before
import streamlit as st
new_df = st.data_editor(old_df)

# After. Note that new_dfs may contain multiple dataframes
from mitosheet.streamlit.v1 import spreadsheet
new_dfs, _ = spreadsheet(old_df)
new_df = list(new_dfs.values()[0]

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.trymito.io/mito-for-streamlit/experienced-streamlit-users.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
